// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: button.c
* - ߲		: IAR EWAAVR 4.11a
*
* - xҰ		: avr@atmel.com
*
* - x޲	: UART/USARTS޲gpł܂B
*				  ATmega169pɏĂ܂B
*
* - pLq	: AVR323 - GSMϕ̲̪
*
* - 		: GSMϕ퐧̂߂AT()gp@̗
*
* $Revision: 1.1 $
* $Date: Tuesday, November 08, 2005 12:25:32 UTC $
*****************************************************************************/


#include <inavr.h>
#include "ioavr.h"
#include "main.h"
#include "button.h"
#include "types.h"


//extern char gPowerSaveTimer;								// ȓd͈ڍsԌvl

unsigned char gButtonTimeout = FALSE;						// ޮèԍXV׸(ݸޖh~up)

char KEY = NULL;											// ޮèԔԍ(l:SOFF)
char KEY_VALID = FALSE;										// ޮèԔԍL׸(l:)



/*****************************************************************************
*
*	֐	: Button_Init
*		: Ȃ
*	߂l	: Ȃ
*	ړI	: 5(ޮè)t݂
*
*****************************************************************************/
void Button_Init(void)
{
    /* ߰ ݏ */
	cbi(DDRB,7);											// PB7()͐ݒ
	cbi(DDRB,6);											// PB6()͐ݒ
	cbi(DDRB,4);											// PB4()͐ݒ
	PORTB |= PINB_MASK;										// PB7/6/4ٱߐݒ
	DDRE = 0x00;											// PE7`0͐ݒ
	PORTE |= PINE_MASK;										// PE3/2ٱߐݒ
	/* ݕω荞݋ */
	PCMSK0 = PINE_MASK;										// PCINT3()/2()荞݋
	PCMSK1 = PINB_MASK;										// PCINT15()/14()/12()荞݋
	EIFR = (1<<PCIF0)|(1<<PCIF1);							// ݕω荞1,0Q荞ݗv׸މ
	EIMSK = (1<<PCIE0)|(1<<PCIE1);							// ݕω荞1,0Q荞݋
}

#pragma vector = PCINT0_vect
__interrupt void PCINT0_interrupt(void)						// ݕω荞0Q荞޸ݒ
{
    PinChangeInterrupt();									// ݕω荞ݏ
}

#pragma vector = PCINT1_vect
__interrupt void PCINT1_interrupt(void)						// ݕω荞1Q荞޸ݒ
{
    PinChangeInterrupt();									// ݕω荞ݏ
}

/*****************************************************************************
*
*	֐	: PinChangeInterrupt
*		: Ȃ
*	߂l	: Ȃ
*	ړI	: ޮè̏Ԃ𒲍
*
*****************************************************************************/
void PinChangeInterrupt(void)
{
	char buttons;											// ޮè _ޯĒl
	char key;												// ޮèԔԍ

	// 擾:
	// Bit             7   6   5   4   3   2   1   0
	// ---------------------------------------------
	// PORTB           B   A       O
	// PORTE                           D   C
	// ---------------------------------------------
	// PORTB | PORTE   B   A       O   D   C
	// =============================================

	buttons = (~PINB) & PINB_MASK;							// ,,_ޯĒl擾
	buttons |= (~PINE) & PINE_MASK;							// ,_ޯĒl擾
    /* ԍ擾 */
	if (buttons & (1<<BUTTON_A))							// ONȂAޮèԔԍ=4
		key = KEY_PLUS;
	else if (buttons & (1<<BUTTON_B))						// ONȂAޮèԔԍ=5
		key = KEY_MINUS;
	else if (buttons & (1<<BUTTON_C))						// ONȂAޮèԔԍ=3
		key = KEY_PREV;
	else if (buttons & (1<<BUTTON_D))						// ONȂAޮèԔԍ=2
		key = KEY_NEXT;
	else if (buttons & (1<<BUTTON_O))						// ONȂAޮèԔԍ=1
		key = KEY_ENTER;
	else													// SOFFȂAޮèԔԍ=0
		key = KEY_NULL;

	if(key != KEY_NULL)										/* ON */
	{
		if(gButtonTimeout)									/* (ޮèԍXV(ݸޖh~ԈȊO)) */
		{
			if (!KEY_VALID)									/* ((ONȂ)) */
			{
				KEY = key;									// ޮèԔԍSϐ֕
				KEY_VALID = TRUE;							// ޮèԔԍL׸ސݒ
			}
			gButtonTimeout = FALSE;							// ޮèԍXV׸މ(ݸޖh~Ԍv)
		}
	}
	EIFR = (1<<PCIF1) | (1<<PCIF0);							// ݕω荞1,0Q荞ݗv׸މ
}

/*****************************************************************************
*
*	֐	: getkey
*		: Ȃ
*	߂l	: Lȷԍ
*	ړI	: Lȷԍ擾
*
*****************************************************************************/
char getkey(void)
{
	char k;													// ޮèԔԍ

	__disable_interrupt();									// S̊荞݋֎~
	if (KEY_VALID)											/* ޮèԔԍL */
	{
		k = KEY;											// ޮèԔԍ
		KEY_VALID = FALSE;									// ޮèԔԍL׸މ
	}
	else													/* ޮèԔԍ */
		k = KEY_NULL;										// SOFFޮèԔԍ擾
	__enable_interrupt();									// S̊荞ݍċ
	return k;												// ޮèԔԍƋɕA
}
